void MeteoPrevisions() {
  WiFiClient client;
  HTTPClient http2;  //Déclarer un objet de classe HTTPClient
  //Appelle les données météorologiques actuelles.
  http2.begin(client, "http://api.openweathermap.org/data/2.5/forecast?q=" + ville + "," + Payscode + "&lang=fr&APPID=" + openWeatherMapApiKey + "&cnt=6&units=metric");  // !!
  httpCode2 = http2.GET();                                                                                                                                                //Envoyer la demande
  if (httpCode2 > 0)                                                                                                                                                      // Vérifie le code de retour
  {
    String payload = http2.getString();  //Obtenir la réponse à la demande
    if (debug == 1) {
      Serial.println("---  Données recu de openweathermap   ---");
      Serial.println(payload);
      Serial.println("-----------------------------------------");
      Serial.println("");
    }
    // Use https://arduinojson.org/v6/assistant to compute the capacity.
    const size_t capacity = JSON_OBJECT_SIZE(544) + JSON_ARRAY_SIZE(239) + 60;
    DynamicJsonDocument infosOP2(capacity);
    // Parse JSON object
    DeserializationError error = deserializeJson(infosOP2, payload);

    if (error) {
      Serial.print(F("deserializeJson() failed: "));
      Serial.println(error.f_str());
      client.stop();
      return;
    }
    //Prevision 0/////////////////////////////////////
    const char* OPIDate0 = infosOP2["list"][0]["dt_txt"];       //Heure des données prévues, ISO, UTC
    unsigned long OPHeureDonnees0 = infosOP2["list"][0]["dt"];  //Heure des données prévues, unix, UTC
    JsonObject weather0 = infosOP2["list"][0]["weather"][0];
    const char* OPIdentIconeMeteo0 = weather0["icon"];               //Identifiant de l'icône météo.
    int OPProbpluie0 = infosOP2["list"][0]["pop"];                   // Probabilité de précipitations. Les valeurs du paramètre varient entre 0 et 1, où 0 est égal à 0%, 1 est égal à 100%
    float OPTempExtMini0 = infosOP2["list"][0]["main"]["temp_min"];  //Température Mini °C.
    float OPTempExtMax0 = infosOP2["list"][0]["main"]["temp_max"];   //Température Max °C.
    int OPDirectionVent0 = infosOP2["list"][0]["wind"]["deg"];       //Direction du vent, degrés (météorologiques).
    float OPVitesseVent0 = infosOP2["list"][0]["wind"]["speed"];     //Vitesse du vent, Unité par défaut : mètre/sec.

    //Prevision 1/////////////////////////////////////
    const char* OPIDate1 = infosOP2["list"][1]["dt_txt"];       //Heure des données prévues, ISO, UTC
    unsigned long OPHeureDonnees1 = infosOP2["list"][1]["dt"];  //Heure des données prévues, unix, UTC
    JsonObject weather1 = infosOP2["list"][1]["weather"][0];
    const char* OPIdentIconeMeteo1 = weather1["icon"];               //Identifiant de l'icône météo.
    int OPProbpluie1 = infosOP2["list"][1]["pop"];                   // Probabilité de précipitations. Les valeurs du paramètre varient entre 0 et 1, où 0 est égal à 0%, 1 est égal à 100%
    float OPTempExtMini1 = infosOP2["list"][1]["main"]["temp_min"];  //Température Mini °C.
    float OPTempExtMax1 = infosOP2["list"][1]["main"]["temp_max"];   //Température Max °C.
    int OPDirectionVent1 = infosOP2["list"][1]["wind"]["deg"];       //Direction du vent, degrés (météorologiques).
    float OPVitesseVent1 = infosOP2["list"][1]["wind"]["speed"];     //Vitesse du vent, Unité par défaut : mètre/sec.

    //Prevision 2/////////////////////////////////////
    const char* OPIDate2 = infosOP2["list"][2]["dt_txt"];       //Heure des données prévues, ISO, UTC
    unsigned long OPHeureDonnees2 = infosOP2["list"][2]["dt"];  //Heure des données prévues, unix, UTC
    JsonObject weather2 = infosOP2["list"][2]["weather"][0];
    const char* OPIdentIconeMeteo2 = weather2["icon"];               //Identifiant de l'icône météo.
    int OPProbpluie2 = infosOP2["list"][2]["pop"];                   // Probabilité de précipitations. Les valeurs du paramètre varient entre 0 et 1, où 0 est égal à 0%, 1 est égal à 100%
    float OPTempExtMini2 = infosOP2["list"][2]["main"]["temp_min"];  //Température Mini °C.
    float OPTempExtMax2 = infosOP2["list"][2]["main"]["temp_max"];   //Température Max °C.
    int OPDirectionVent2 = infosOP2["list"][2]["wind"]["deg"];       //Direction du vent, degrés (météorologiques).
    float OPVitesseVent2 = infosOP2["list"][2]["wind"]["speed"];     //Vitesse du vent, Unité par défaut : mètre/sec.

    //Prevision 3/////////////////////////////////////
    const char* OPIDate3 = infosOP2["list"][3]["dt_txt"];       //Heure des données prévues, ISO, UTC
    unsigned long OPHeureDonnees3 = infosOP2["list"][3]["dt"];  //Heure des données prévues, unix, UTC
    JsonObject weather3 = infosOP2["list"][3]["weather"][0];
    const char* OPIdentIconeMeteo3 = weather3["icon"];               //Identifiant de l'icône météo.
    int OPProbpluie3 = infosOP2["list"][3]["pop"];                   // Probabilité de précipitations. Les valeurs du paramètre varient entre 0 et 1, où 0 est égal à 0%, 1 est égal à 100%
    float OPTempExtMini3 = infosOP2["list"][3]["main"]["temp_min"];  //Température Mini °C.
    float OPTempExtMax3 = infosOP2["list"][3]["main"]["temp_max"];   //Température Max °C.
    int OPDirectionVent3 = infosOP2["list"][3]["wind"]["deg"];       //Direction du vent, degrés (météorologiques).
    float OPVitesseVent3 = infosOP2["list"][3]["wind"]["speed"];     //Vitesse du vent, Unité par défaut : mètre/sec.

    //Prevision 4/////////////////////////////////////
    const char* OPIDate4 = infosOP2["list"][4]["dt_txt"];       //Heure des données prévues, ISO, UTC
    unsigned long OPHeureDonnees4 = infosOP2["list"][4]["dt"];  //Heure des données prévues, unix, UTC
    JsonObject weather4 = infosOP2["list"][4]["weather"][0];
    const char* OPIdentIconeMeteo4 = weather4["icon"];               //Identifiant de l'icône météo.
    int OPProbpluie4 = infosOP2["list"][4]["pop"];                   // Probabilité de précipitations. Les valeurs du paramètre varient entre 0 et 1, où 0 est égal à 0%, 1 est égal à 100%
    float OPTempExtMini4 = infosOP2["list"][4]["main"]["temp_min"];  //Température Mini °C.
    float OPTempExtMax4 = infosOP2["list"][4]["main"]["temp_max"];   //Température Max °C.
    int OPDirectionVent4 = infosOP2["list"][4]["wind"]["deg"];       //Direction du vent, degrés (météorologiques).
    float OPVitesseVent4 = infosOP2["list"][4]["wind"]["speed"];     //Vitesse du vent, Unité par défaut : mètre/sec.

    //Prevision 5/////////////////////////////////////
    const char* OPIDate5 = infosOP2["list"][5]["dt_txt"];       //Heure des données prévues, ISO, UTC
    unsigned long OPHeureDonnees5 = infosOP2["list"][5]["dt"];  //Heure des données prévues, unix, UTC
    JsonObject weather5 = infosOP2["list"][5]["weather"][0];
    const char* OPIdentIconeMeteo5 = weather5["icon"];               //Identifiant de l'icône météo.
    int OPProbpluie5 = infosOP2["list"][5]["pop"];                   // Probabilité de précipitations. Les valeurs du paramètre varient entre 0 et 1, où 0 est égal à 0%, 1 est égal à 100%
    float OPTempExtMini5 = infosOP2["list"][5]["main"]["temp_min"];  //Température Mini °C.
    float OPTempExtMax5 = infosOP2["list"][5]["main"]["temp_max"];   //Température Max °C.
    int OPDirectionVent5 = infosOP2["list"][5]["wind"]["deg"];       //Direction du vent, degrés (météorologiques).
    float OPVitesseVent5 = infosOP2["list"][5]["wind"]["speed"];     //Vitesse du vent, Unité par défaut : mètre/sec.


    if (debug == 1) {
      Serial.println("--- Details de l'ensemble des donnees ---");
      Serial.println("--- Prevision N°0 ---");
      Serial.printf("Date et Heure des données prévues :  %s\r\n", OPIDate0);
      Serial.printf("Heure des données prévues :  %02d:%02d:%02d\n", hour(OPHeureDonnees0), minute(OPHeureDonnees0), second(OPHeureDonnees0));
      Serial.printf("Identifiant de l'icône météo :  %d %%\r\n", OPIdentIconeMeteo0);
      Serial.printf("Probabilité de précipitations :  %d %%\r\n", OPProbpluie0);
      Serial.printf("Température Mini :  %.2f °C\r\n", OPTempExtMini0);
      Serial.printf("Température Max :  %.2f °C\r\n", OPTempExtMax0);
      Serial.printf("Direction du vent :  %d %%\r\n", OPDirectionVent0);
      Serial.printf("Vitesse du vent :  %.2f mètre/sec\r\n", OPVitesseVent0);
      Serial.println("");
      
      Serial.println("--- Prevision N°1 ---");
      Serial.printf("Date et Heure des données prévues :  %s\r\n", OPIDate1);
      Serial.printf("Heure des données prévues :  %02d:%02d:%02d\n", hour(OPHeureDonnees1), minute(OPHeureDonnees1), second(OPHeureDonnees1));
      Serial.printf("Identifiant de l'icône météo :  %d %%\r\n", OPIdentIconeMeteo1);
      Serial.printf("Probabilité de précipitations :  %d %%\r\n", OPProbpluie1);
      Serial.printf("Température Mini :  %.2f °C\r\n", OPTempExtMini1);
      Serial.printf("Température Max :  %.2f °C\r\n", OPTempExtMax1);
      Serial.printf("Direction du vent :  %d %%\r\n", OPDirectionVent1);
      Serial.printf("Vitesse du vent :  %.2f mètre/sec\r\n", OPVitesseVent1);
      Serial.println("");

      Serial.println("--- Prevision N°2 ---");
      Serial.printf("Date et Heure des données prévues :  %s\r\n", OPIDate2);
      Serial.printf("Heure des données prévues :  %02d:%02d:%02d\n", hour(OPHeureDonnees2), minute(OPHeureDonnees2), second(OPHeureDonnees2));
      Serial.printf("Identifiant de l'icône météo :  %d %%\r\n", OPIdentIconeMeteo2);
      Serial.printf("Probabilité de précipitations :  %d %%\r\n", OPProbpluie2);
      Serial.printf("Température Mini :  %.2f °C\r\n", OPTempExtMini2);
      Serial.printf("Température Max :  %.2f °C\r\n", OPTempExtMax2);
      Serial.printf("Direction du vent :  %d %%\r\n", OPDirectionVent2);
      Serial.printf("Vitesse du vent :  %.2f mètre/sec\r\n", OPVitesseVent2);
      Serial.println("");
      
      Serial.println("--- Prevision N°3 ---");
      Serial.printf("Date et Heure des données prévues :  %s\r\n", OPIDate3);
      Serial.printf("Heure des données prévues :  %02d:%02d:%02d\n", hour(OPHeureDonnees3), minute(OPHeureDonnees3), second(OPHeureDonnees3));
      Serial.printf("Identifiant de l'icône météo :  %d %%\r\n", OPIdentIconeMeteo3);
      Serial.printf("Probabilité de précipitations :  %d %%\r\n", OPProbpluie3);
      Serial.printf("Température Mini :  %.2f °C\r\n", OPTempExtMini3);
      Serial.printf("Température Max :  %.2f °C\r\n", OPTempExtMax3);
      Serial.printf("Direction du vent :  %d %%\r\n", OPDirectionVent3);
      Serial.printf("Vitesse du vent :  %.2f mètre/sec\r\n", OPVitesseVent3);
      Serial.println("");

      Serial.println("--- Prevision N°4 ---");
      Serial.printf("Date et Heure des données prévues :  %s\r\n", OPIDate4);
      Serial.printf("Heure des données prévues :  %02d:%02d:%02d\n", hour(OPHeureDonnees4), minute(OPHeureDonnees4), second(OPHeureDonnees4));
      Serial.printf("Identifiant de l'icône météo :  %d %%\r\n", OPIdentIconeMeteo4);
      Serial.printf("Probabilité de précipitations :  %d %%\r\n", OPProbpluie4);
      Serial.printf("Température Mini :  %.2f °C\r\n", OPTempExtMini4);
      Serial.printf("Température Max :  %.2f °C\r\n", OPTempExtMax4);
      Serial.printf("Direction du vent :  %d %%\r\n", OPDirectionVent4);
      Serial.printf("Vitesse du vent :  %.2f mètre/sec\r\n", OPVitesseVent4);
      Serial.println("");

      Serial.println("--- Prevision N°5 ---");
      Serial.printf("Date et Heure des données prévues :  %s\r\n", OPIDate5);
      Serial.printf("Heure des données prévues :  %02d:%02d:%02d\n", hour(OPHeureDonnees5), minute(OPHeureDonnees5), second(OPHeureDonnees5));
      Serial.printf("Identifiant de l'icône météo :  %d %%\r\n", OPIdentIconeMeteo5);
      Serial.printf("Probabilité de précipitations :  %d %%\r\n", OPProbpluie5);
      Serial.printf("Température Mini :  %.2f °C\r\n", OPTempExtMini5);
      Serial.printf("Température Max :  %.2f °C\r\n", OPTempExtMax5);
      Serial.printf("Direction du vent :  %d %%\r\n", OPDirectionVent5);
      Serial.printf("Vitesse du vent :  %.2f mètre/sec\r\n", OPVitesseVent5);
      Serial.println("------------------------------------------");
      Serial.println("");
      Serial.println("");
    }

    else {
      //Prevision 0/////////////////////////////////////
      //Date des données prévues
      int AA, MM, JJ, hh, mm, ss;
      sscanf(OPIDate0, "%d-%d-%d %d:%d:%d", &AA, &MM, &JJ, &hh, &mm, &ss);
      sprintf(buffer, "%02d/%02d\r\n", JJ, MM);
      page0t26.setText(buffer);

      //Heure des données prévues
      sprintf(buffer, "%02dh\r\n", hour(OPHeureDonnees0));
      page0t27.setText(buffer);

      //Envoie Identifiant de l'icône météo Nextion
      uint32_t IDIcone0 = (CielIconeMeteo(OPIdentIconeMeteo0));
      page0p2.setPic(IDIcone0);

      //Probabilité de précipitations
      sprintf(buffer, "%d %%\r\n", OPProbpluie0);
      page0t29.setText(buffer);

      //Envoie Temperature Max °C Nextion
      sprintf(buffer, "%.1f%c\r\n", OPTempExtMax0, 0xB0);
      page0t30.setText(buffer);

      //Envoie Temperature Mini ° Nextion
      sprintf(buffer, "%.1f%c\r\n", OPTempExtMini0, 0xB0);
      page0t31.setText(buffer);

      //Envoie Direction du vent Nextion.
      IDIcone0 = (DirVentIcone(OPDirectionVent0));
      page0p4.setPic(IDIcone0);

      //Envoie Vitesse du vent Nextion.
      OPVitesseVent0 = OPVitesseVent0 * 3.6;  //Vitesse du vent km/h.
      sprintf(buffer, "%.0fKm/h\r\n", OPVitesseVent0);
      page0t32.setText(buffer);


      //Prevision 1/////////////////////////////////////
      //Date des données prévues
      sscanf(OPIDate1, "%d-%d-%d %d:%d:%d", &AA, &MM, &JJ, &hh, &mm, &ss);
      sprintf(buffer, "%02d/%02d\r\n", JJ, MM);
      page0t33.setText(buffer);
      //Heure des données prévues
      sprintf(buffer, "%02dh\r\n", hour(OPHeureDonnees1));
      page0t34.setText(buffer);

      //Envoie Identifiant de l'icône météo Nextion
      uint32_t IDIcone1 = (CielIconeMeteo(OPIdentIconeMeteo1));
      page0p5.setPic(IDIcone1);

      //Probabilité de précipitations
      sprintf(buffer, "%d %%\r\n", OPProbpluie1);
      page0t36.setText(buffer);

      //Envoie Temperature Max °C Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMax1, 0xB0);
      page0t37.setText(buffer);

      //Envoie Temperature Mini ° Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMini1, 0xB0);
      page0t38.setText(buffer);

      //Envoie Direction du vent Nextion.
      IDIcone1 = (DirVentIcone(OPDirectionVent1));
      page0p7.setPic(IDIcone1);

      //Envoie Vitesse du vent Nextion.
      OPVitesseVent1 = OPVitesseVent1 * 3.6;  //Vitesse du vent km/h.
      sprintf(buffer, "%.0fKm/h\r\n", OPVitesseVent1);
      page0t39.setText(buffer);

      //Prevision 2/////////////////////////////////////
      //Date des données prévues
      sscanf(OPIDate2, "%d-%d-%d %d:%d:%d", &AA, &MM, &JJ, &hh, &mm, &ss);
      sprintf(buffer, "%02d/%02d\r\n", JJ, MM);
      page0t40.setText(buffer);
      //Heure des données prévues
      sprintf(buffer, "%02dh\r\n", hour(OPHeureDonnees2));
      page0t41.setText(buffer);

      //Envoie Identifiant de l'icône météo Nextion
      uint32_t IDIcone2 = (CielIconeMeteo(OPIdentIconeMeteo2));
      page0p8.setPic(IDIcone2);

      //Probabilité de précipitations
      sprintf(buffer, "%d %%\r\n", OPProbpluie2);
      page0t43.setText(buffer);

      //Envoie Temperature Max °C Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMax2, 0xB0);
      page0t44.setText(buffer);

      //Envoie Temperature Mini ° Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMini2, 0xB0);
      page0t45.setText(buffer);

      //Envoie Direction du vent Nextion.
      IDIcone2 = (DirVentIcone(OPDirectionVent2));
      page0p10.setPic(IDIcone2);

      //Envoie Vitesse du vent Nextion.
      OPVitesseVent2 = OPVitesseVent2 * 3.6;  //Vitesse du vent km/h.
      sprintf(buffer, "%.0fKm/h\r\n", OPVitesseVent2);
      page0t46.setText(buffer);

      //Prevision 3/////////////////////////////////////
      //Date des données prévues
      sscanf(OPIDate3, "%d-%d-%d %d:%d:%d", &AA, &MM, &JJ, &hh, &mm, &ss);
      sprintf(buffer, "%02d/%02d\r\n", JJ, MM);
      page0t47.setText(buffer);
      //Heure des données prévues
      sprintf(buffer, "%02dh\r\n", hour(OPHeureDonnees3));
      page0t48.setText(buffer);

      //Envoie Identifiant de l'icône météo Nextion
      uint32_t IDIcone3 = (CielIconeMeteo(OPIdentIconeMeteo3));
      page0p11.setPic(IDIcone3);

      //Probabilité de précipitations
      sprintf(buffer, "%d %%\r\n", OPProbpluie3);
      page0t50.setText(buffer);

      //Envoie Temperature Max °C Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMax3, 0xB0);
      page0t51.setText(buffer);

      //Envoie Temperature Mini ° Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMini3, 0xB0);
      page0t52.setText(buffer);

      //Envoie Direction du vent Nextion.
      IDIcone3 = (DirVentIcone(OPDirectionVent3));
      page0p13.setPic(IDIcone3);

      //Envoie Vitesse du vent Nextion.
      OPVitesseVent3 = OPVitesseVent3 * 3.6;  //Vitesse du vent km/h.
      sprintf(buffer, "%.0fKm/h\r\n", OPVitesseVent3);
      page0t53.setText(buffer);

      //Prevision 4/////////////////////////////////////
      //Date des données prévues
      sscanf(OPIDate4, "%d-%d-%d %d:%d:%d", &AA, &MM, &JJ, &hh, &mm, &ss);
      sprintf(buffer, "%02d/%02d\r\n", JJ, MM);
      page0t54.setText(buffer);

      //Heure des données prévues
      sprintf(buffer, "%02dh\r\n", hour(OPHeureDonnees4));
      page0t55.setText(buffer);

      //Envoie Identifiant de l'icône météo Nextion
      uint32_t IDIcone4 = (CielIconeMeteo(OPIdentIconeMeteo4));
      page0p14.setPic(IDIcone4);

      //Probabilité de précipitations
      sprintf(buffer, "%d %%\r\n", OPProbpluie4);
      page0t57.setText(buffer);

      //Envoie Temperature Max °C Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMax4, 0xB0);
      page0t58.setText(buffer);

      //Envoie Temperature Mini ° Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMini4, 0xB0);
      page0t59.setText(buffer);

      //Envoie Direction du vent Nextion.
      IDIcone4 = (DirVentIcone(OPDirectionVent4));
      page0p16.setPic(IDIcone4);

      //Envoie Vitesse du vent Nextion.
      OPVitesseVent4 = OPVitesseVent4 * 3.6;  //Vitesse du vent km/h.
      sprintf(buffer, "%.0fKm/h\r\n", OPVitesseVent4);
      page0t60.setText(buffer);

      //Prevision 5/////////////////////////////////////
      //Date des données prévues
      sscanf(OPIDate5, "%d-%d-%d %d:%d:%d", &AA, &MM, &JJ, &hh, &mm, &ss);
      sprintf(buffer, "%02d/%02d\r\n", JJ, MM);
      page0t61.setText(buffer);

      //Heure des données prévues
      sprintf(buffer, "%02dh\r\n", hour(OPHeureDonnees5));
      page0t62.setText(buffer);

      //Envoie Identifiant de l'icône météo Nextion
      uint32_t IDIcone5 = (CielIconeMeteo(OPIdentIconeMeteo5));
      page0p17.setPic(IDIcone5);

      //Probabilité de précipitations
      sprintf(buffer, "%d %%\r\n", OPProbpluie5);
      page0t64.setText(buffer);

      //Envoie Temperature Max °C Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMax5, 0xB0);
      page0t65.setText(buffer);

      //Envoie Temperature Mini ° Nextion
      sprintf(buffer, "%.1f%c \r\n", OPTempExtMini5, 0xB0);
      page0t66.setText(buffer);

      //Envoie Direction du vent Nextion.
      IDIcone5 = (DirVentIcone(OPDirectionVent5));
      page0p19.setPic(IDIcone5);

      //Envoie Vitesse du vent Nextion.
      OPVitesseVent5 = OPVitesseVent5 * 3.6;  //Vitesse du vent km/h.
      sprintf(buffer, "%.0fKm/h\r\n", OPVitesseVent5);
      page0t67.setText(buffer);
    }
  }
}